mSNESRomLow dw 0
mSNESRom dw 0
mERROR dw 0

mXMS db 0
mXMSC dd 0
mXMSH dw 0
mXMSPTR dd 0
mROM dd 0
mRAM dd 0
mSRAM dd 0
mVRAM dd 0

mLUT dd 512 DUP (0)

mMsgInit db 'Initializing Snes ROM memory...',13,10,'$'
mMsgFail db 'Unable to allocate ROM memory (Error #1001)',13,10,'$'
mMsgExtF db 'Unable to allocate ROM extended memory (Error #1002)',13,10,'$'
mMsgFile db 'Unable to open SONIC.SMC (Error #t2001)',13,10,'$'
mMsgWind db 'Windows 95 prevents direct XMS access.  You must restart in DOS mode.',13,10,'$'

mFileName DB 'DEBUG.SMC',0,0,0,0
mFileHandle dw 0
mROMSize dd 0          ;in Bytes
mSLen dd 0
mSSH dw 0
mSSO dd 0
mSDH dw 0
mSDO dd 0


SNESRomInit PROC NEAR
  mov ax,cs
  mov ds,ax                    ;Point DS to CS
  mov ah,9                     ;
  mov dx,OFFSET mMsgInit       ;
  int 21h                      ;Display Initializtion message
  mov ax,04300h                ;test for XMS driver
  int 2fh                      ;
  cmp al,80h                   ;
  je SHORT IsXMSDRVS           ;
  SRIS2:
  mov [mERROR],1002            ;XMS driver not present, display error msg
  mov dx,OFFSET mMsgExtF       ;
  mov ah,9                     ;
  int 21h                      ;
  SRIS3:
  mov ax,@data                 ;Restore DS to data segment
  mov ds,ax                    ;
  ret                          ;
  IsXMSDRVS:                   ;XMS driver present
  mov ax,4310h                 ;
  int 2fh                      ;
  mov WORD PTR [mXMSC],bx      ;
  mov WORD PTR [mXMSC+2],es    ;get XMS entry point

  mov ah,03h
  call [mXMSC]

  mov ah,09h                   ;  XMS-alloc function
  mov dx,4320                  ;  size in KB to allocate (4096+128+32+64)
  call [mXMSC]                 ;attempt to allocate extended memory
  mov [mXMSH],dx               ;preserve XMS handle
  cmp ax,0                     ;test for error in XMS allocation
  je SHORT SRIS2               ;
                               
  mov dx,OFFSET [mFileName]    ;set DS:DX to filename
  mov ax,03d00h                ;
  int 21h                      ;Open file
  mov bx,ax                    ;
  mov [mFileHandle],bx         ;preserve file handle
  jnc LoadSNES1                ;test for error
  mov [mERROR],2001            ;Unable to open file, display error msg
  mov dx,OFFSET mMsgFile       ;
  mov ah,9                     ;
  int 21h                      ;
  mov ah,0ah                   ;
  mov dx,[mXMSH]               ;
  call [mXMSC]                 ;free XMS
  jmp SRIS3                    ;
  LoadSNES1:                   ;File opened properly
  mov ax,04202h                ;
  xor cx,cx                    ;
  xor dx,dx                    ;
  int 21h                      ;find EOF
  mov WORD PTR [mROMSize],ax   ;
  mov WORD PTR [mROMSize+2],dx ;Preserve raw File Size
  mov ax,04200h                ;
  xor cx,cx                    ;
  mov dx,512                   ;skip SMC header
  int 21h                      ;reset file pointer to start of file
  mov ecx,[mROMSize]           ;
  sub ecx,512                  ;
  mov [mROMSize],ecx           ;subtract out SMC header
  shr ecx,15                   ;convert to 32k chunks
  mov [mSLen],32768                  ;Chunk size
  mov [mSSH],0                       ;source is conventional
  mov WORD PTR [mSSO],OFFSET RBuf
  mov WORD PTR [mSSO+2],SEG RBuf
  mov ax,[mXMSH]                     ;XMS Handle
  mov [mSDH],ax                      ;
  mov [mSDO],0                       ;Initial XMS offset

  SRILoop:
  ror ecx,16                   ;preserve count
  mov dx,OFFSET RBuf           ;set offset
  mov ax,SEG RBuf              ;get conventional segment
  mov ds,ax                    ;
  mov cx,32768                 ;set chunk length
  mov ah,03fh                  ;
  int 21h                      ;load chunk
                               
  mov ax,cs                    ;
  mov ds,ax                    ;set DS to CS
  mov si,OFFSET [mSLen]        ;get pointer to EMMS
  mov ah,0bh                   ;
  call [mXMSC]                 ;move chunk to XMS
  add DWORD PTR [mSDO],32768   ;increment chunk position

  ror ecx,16                   ;restore count
  loop SRILoop                 ;get next chunk

  mov ah,03eh                  ;
  int 21h                      ;Close file

  mov ah,0ch                   ;Lock XMS block command
  mov dx,[mXMSH]
  call [mXMSC]
  cmp ax,1
  je SRIFIN                    ;Test for valid XMS lock
  mov dx,OFFSET [mMsgWind]       ;didn't work, so quit
  mov ah,09h
  int 21h
  mov ah,04ch
  int 21h

  SRIFIN:                      ;XMS was valid!
  mov WORD PTR [mXMSPTR],bx
  mov WORD PTR [mXMSPTR+2],dx  ;Preserve XMS block pointer
  mov ebx,[mXMSPTR]
  mov [mROM],ebx
  add ebx,4194304
  mov [mRAM],ebx               ;Preserve 32bit Pointers
  add ebx,131072
  mov [mSRAM],ebx
  add ebx,65536
  mov [mVRAM],ebx

  mov edx,[mXMSPTR]
  mov bx,4
  mov cx,255
  mLUTLoop:
  mov DWORD PTR [mLUT+bx],edx
  add bx,8
  add edx,32768
  loop mLUTLoop
  mov bx,896
  mov edx,[mSRAM]
  mov DWORD PTR [mLUT+bx],edx
  mov bx,1008
  mov edx,[mRAM]
  mov DWORD PTR [mLUT+bx],edx
  add bx,4
  add edx,32768
  mov DWORD PTR [mLUT+bx],edx
  add bx,4
  add edx,32768
  mov DWORD PTR [mLUT+bx],edx
  add bx,4
  add edx,32768
  mov DWORD PTR [mLUT+bx],edx      ;Create memory bank LUT (upper 9-bit AA)


  mov ax,@data
  mov ds,ax                    ;Restore DS
  ret
ENDP

SNESRomKill PROC NEAR
  mov ah,0dh
  mov dx,[mXMSH]
  call [mXMSC]                 ;Unlock XMS block
  mov ah,0ah                   ;free XMS
  mov dx,[mXMSH]               ;
  call [mXMSC]                 ;
  ret                          ;
ENDP

SNESRomPage PROC NEAR    ;In:  bx=chunk#
  mov [mSLen],32768                  ;Chunk size
  mov [mSDH],0                       ;destination is conventional
  mov WORD PTR [mSDO+2],SEG RBuf     ;get conventional address
  mov WORD PTR [mSDO],OFFSET RBuf    ;
  mov ax,[mXMSH]                     ;XMS Handle
  mov [mSSH],ax                      ;
  and ebx,0ffffh                     ;clear ebxh
  shl ebx,15                         ;get chunk pointer
  mov [mSSO],ebx                     ;Initial XMS offset
  mov ax,cs                          ;
  mov ds,ax                          ;
  mov si, OFFSET [mSLen]             ;get ds:si ptr to EMMS
  mov ah,0bh                         ;
  call [mXMSC]                       ;move chunk from XMS to conventional

  mov ax,@data                       ;
  mov ds,ax                          ;restore DS
  ret                                ;
ENDP

;In: ah:bx=24-bit ptr   OUT=al
xMemRead PROC NEAR   ;Implemented for LoRom only so far...
  mov gs,ax
  mov fs,bx
  push dx
  mov al,ah
  xor ah,ah
  shl ax,3
  test bx,32768
  jz SHORT xMemReadS
  add ax,4
  xMemReadS:
  xchg ax,bx
  mov edx,[mLUT+bx]
  cmp edx,0
  jz SHORT xMemReadL
  and ax,32767
  cwde
  add edx,eax
  mov bx,fs
  xor ax,ax
  mov fs,ax
  mov ax,gs
  mov al,BYTE PTR fs:[edx]
  IFDEF EDEBUG
    call DebugRead
    push bx
    mov bl,al
    xor bh,bh
    call DebugVal
    pop bx
  ENDIF
  pop dx
  ret
  xMemReadL:
  mov ax,gs
  mov bx,fs
  cmp bx,2000h
  jnb SHORT xMemReadLB
  mov edx,[mRAM]
  mov ax,bx
  cwde
  add edx,eax
  mov bx,fs
  xor ax,ax
  mov fs,ax
  mov ax,gs

  mov al,BYTE PTR fs:[edx]

  IFDEF EDEBUG
    push 3000h
    pop gs
    call DebugMsg
    call DebugRead
    push bx
    mov bl,al
    xor bh,bh
    call DebugVal
    pop bx
  ENDIF
  pop dx
  ret
  xMemReadLB:
  ;----Register mapping goes here!
  cmp bh,21h
  jne SHORT xRRA
  call r21Read
  pop dx
  ret
  xRRA:
  cmp bh,42h
  jne SHORT xRRB
  call r42Read
  pop dx
  ret
  xRRB:
  cmp bh,43h
  jne SHORT xRRC
  call r43Read
  pop dx
  ret
  xRRC:
  ;Illegal sub-8000 pointer (in LowRom mode anyway)

  push 3002h
  pop gs
;  call DebugMsg
  pop dx
  ret
ENDP

xMemWrite PROC NEAR
  mov gs,ax
  mov fs,bx
  push dx
  mov al,ah
  xor ah,ah
  shl ax,3
  test bx,32768
  jz SHORT xMemWriteS
  add ax,4
  xMemWriteS:
  xchg ax,bx
  mov edx,[mLUT+bx]
  cmp edx,0
  jz SHORT xMemWriteL
  and ax,32767
  cwde
  add edx,eax
  mov bx,fs
  xor ax,ax
  mov fs,ax
  mov ax,gs
  mov BYTE PTR fs:[edx],al
  IFDEF EDEBUG
    call DebugWrite
    push bx
    mov bl,al
    xor bh,bh
    call DebugVal
    pop bx
  ENDIF
  pop dx
  ret
  xMemWriteL:
  mov ax,gs
  mov bx,fs
  cmp bx,2000h
  jnb SHORT xMemWriteLB
  mov edx,[mRAM]
  mov ax,bx
  cwde
  add edx,eax
  mov bx,fs
  xor ax,ax
  mov fs,ax
  mov ax,gs

  mov BYTE PTR fs:[edx],al

  IFDEF EDEBUG
    call DebugWrite
    push bx
    mov bl,al
    xor bh,bh
    call DebugVal
    pop bx
  ENDIF
  pop dx
  ret
  xMemWriteLB:
  ;Register mapping goes here!
  cmp bh,21h
  jne SHORT xWRA
  call r21Write
  pop dx
  ret
  xWRA:
  cmp bh,42h
  jne SHORT xWRB
  call r42Write
  pop dx
  ret
  xWRB:
  cmp bh,43h
  jne SHORT xWRC
  call r43Write
  pop dx
  ret
  xWRC:
  ;Illegal sub-8000 pointer (in LowRom mode anyway)

  push 3003h
  pop gs
;  call DebugMsg
  pop dx
  ret
ENDP

